# IOzone

## 简介

[Iozone Filesystem Benchmark](https://www.iozone.org/)

IOzone 是一个广泛使用的文件系统基准测试工具，主要用于测试和测量不同操作系统和硬件环境下的文件系统性能。它通过创建、读取、重写、重新读取等多种操作来评估文件系统的性能。

执行以下操作

*Read, write, **re-read, re-write, read backwards, read strided**, fread, fwrite, random read, pread ,mmap, aio_read, aio_write*

## 使用iozone

```shell
进入文件夹
cd .../iozone

#编译
make linux-AMD64
如果编译输出了大量警告信息，修改makefile的第17行代码
CFLAGS    ?=
修改为
CFLAGS    += -Wno-format-overflow
然后重新终端中执行
make linux-AMD64

#运行iozone
./iozone -a
#可以设置别的参数，参考如下链接
```

[IOzone I/O测试工具使用说明](https://blog.csdn.net/IT_xiao_bai0516/article/details/128646544)

## 实现

需要添加新的系统调用
IOzone 在测试过程中会使用多种系统调用来评估文件系统的性能。以下是一些常见的系统调用，包含它们的原型、功能和参数说明。

1. ~~open() 已实现~~
2. ~~read()~~
3. ~~write()~~
4. ~~lseek()~~
5. ~~close()~~
6. ~~fstat()~~
7. ~~mmap()~~
8. ~~munmap()~~
9. **fsync()**

```c
int fsync(int fd);
```

将文件描述符 `fd` 关联的文件的所有已修改数据写入存储设备。

**参数说明**：

- `fd`：文件描述符。

10. **ioctl()**

```c
int ioctl(int fd, unsigned long request, ...);
```

设备控制操作，用于管理和操作文件描述符 `fd` 关联的设备。

**参数说明**：

- `fd`：文件描述符。
- `request`：设备控制请求码。
- 额外的参数视 `request` 而定。
