# Lua

[Lua 教程](https://www.runoob.com/lua/lua-tutorial.html)

## 简介 [Lua 教程 (runoob.com)](https://www.runoob.com/lua/lua-tutorial.html)

Lua 是一种轻量小巧的脚本语言，用标准C语言编写并以源代码形式开放， 其设计目的是为了嵌入应用程序中

## 基础语法

[三十分钟入门 lua - 个人文章 - SegmentFault 思否](https://segmentfault.com/a/1190000022732306)

## 安装并使用lua

[Lua:01---Lua语言介绍、运行Lua程序（lua解释器）-CSDN博客](https://blog.csdn.net/qq_41453285/article/details/107923366)

```shell
#下载源码，进入目录
#我下载了整个[oscomp/testsuits-for-oskernel at final-2024-rv (github.com)](https://github.com/oscomp/testsuits-for-oskernel/tree/final-2024-rv)仓库，进入lua文件夹
cd .../testsuits-for-oskernel-final-2024-rv/lua

#编译
make linux test

#检查
ls src/
#出现lua,luac两个可执行程序

#安装lua
sudo make install

#刷新动态库链接
sudo ldconfig

#查看lua安装的版本
lua -v
```

![luademo](../img/luaDemo.png)

## 实现

为了能在我们的系统中使用lua，需要添加新的系统调用。

```c
int access(const char *pathname, int mode);
```

`access()` 系统调用用于检查调用进程是否可以以特定模式访问指定的文件。它不会考虑实际的用户和组权限，而是直接检查文件的权限位。

- `const char *pathname`: 要检查的文件路径。
- `int mode`: 访问模式，可以是以下值的组合：
  - `F_OK`: 检查文件是否存在。
  - `R_OK`: 检查读权限。
  - `W_OK`: 检查写权限。
  - `X_OK`: 检查执行权限。

```c
int close(int fd);
```

关闭一个文件描述符，从而释放该描述符所指向的文件或资源。关闭文件描述符后，该描述符将不再可用。

- `int fd`: 要关闭的文件描述符。

```c
void exit_group(int status);
```

终止一个进程组的所有线程。这与 `exit()` 系统调用类似，但 `exit_group()` 会使所有线程立即退出，而不仅仅是调用线程。

- `int status`: 返回给父进程的退出状态。该状态将传递给等待该进程组的父进程。
