# 目录结构

kernel：	内核代码和头文件

linkscipt： 链接脚本

user:：xv6 自带的应用程序

mkfs：制作文件系统镜像，这个不管还没用



# run

使用makefile

```makefile
make fs
make run
```





# fat32结构

介绍：FAT 是用簇来管理**数据区**的（但是对于保留区和 FAT 表，依然是用扇区进行管理的）。 簇是由多个连续的扇区组成的，我们为某个文件分配数据区的一片区域时，只能分配一个簇而不能分配一个扇区或者一个字节，这是因为扇区或者字节这样的单位过于细小，对其逐个编号十分浪费空间。

![image-20230505152650101](https://cdn.jsdelivr.net/gh/Ywinh/TyporaImages@main/202404072129697.png)





# 说明

主要关注 kernel/fat.c kernel/include/fat.h

另外抄的一个 kernel/include/FileSystem.h  kernel/FileSystem.c 这两个应该是为了方便后续写 vfs 方便，如果一直跑不起来的话我可能会删掉这个

可以参考：

[Exaros：fat32的介绍](https://gitlab.eduxiji.net/Thysrael/exaros/-/blob/master/doc/fat.md)

[fat32提供的api：写系统调用可能需要](https://gitlab.eduxiji.net/educg-group-13484-858191/19373469-1384/-/blob/develop/docs/fat-impl.md)

[可参考这个实现系统调用](https://gitlab.eduxiji.net/educg-group-13484-858191/19373469-1384/-/blob/develop/docs/fat-syscall.md)





这些不太会用到，一般用的都是 superblock，dirent

列出来供参考

```c
typedef struct FAT32BootParamBlock {
	// 通用的引导扇区属性
	u8 BS_jmpBoot[3];
	u8 BS_OEMName[8];
	u16 BPB_BytsPerSec; // 一个扇区的字节数，一般是 512   可选512,1024,2048,4096
	u8 BPB_SecPerClus; // 一个簇的扇区数。需要是 2 的幂次
	u16 BPB_RsvdSecCnt; // 保留区域的总扇区数，保留区域是 FAT 卷的第一个区域
	u8 BPB_NumFATs; // FAT 表的个数，恒为 2
	u16 BPB_RootEntCnt; // 根目录中 32 字节目录条目的数量, FAT32 设置为 0
	u16 BPB_TotSec16;
	u8 BPB_Media;
	u16 BPB_FATSz16; // 每个 FAT 的扇区数
	u16 BPB_SecPerTrk;
	u16 BPB_NumHeads;
	u32 BPB_HiddSec;
	u32 BPB_TotSec32; // FAT 卷的扇区总数。 该值是包括卷的所有区域在内的扇区总数
	// FAT32 引导扇区属性  special for FAT32
	u32 BPB_FATSz32; // 32-bit count of sectors occupied by ONE FAT
	u16 BPB_ExtFlags; //  0-3 : Zero-based number of active FAT
    // 4-6 : Reserved
    // 7 : 0 means the FAT is mirrored at runtime into all FATs
    //     1 means only one FAT is active; it is the one referenced in bits 0-3
    // 8-15 : Reserved
	u16 BPB_FSVer;
	u32 BPB_RootClus; // 根目录（也就是数据区域）的第一个簇的编号。 它通常设置为 2，即卷的第一个簇
	u16 BPB_FSInfo; // FSINFO 结构扇区的起始 number 通常设置为 1
	u16 BPB_BkBootSec; // 备份引导扇区的起始 number 通常设置为 6
	u8 BPB_Reserved[12];
	u8 BS_DrvNum;
	u8 BS_Reserved1;
	u8 BS_BootSig;
	u32 BS_VolID;
	u8 BS_VolLab[11];
	u8 BS_FilSysType[8]; // System identifier string  "FAT32 "
	u8 BS_CodeReserved[420]; // boot code
	u8 BS_Signature[2]; // Bootable partition signature 0xAA55. 必须为这个字段 boot sector 才有用
} __attribute__((packed)) fat_bpb_t;
```



```c
// FAT32 Fsinfo
typedef struct FAT32_FSinfo {
    uchar LeadSig[4]; // validate that this is in fact an FSInfo sector
    // Value 0x41615252
    uchar Reserved1[480]; // is currently reserved for future expansion,set to 0
    uchar StrucSig[4];    // is more localized in the sector to the location of the fields that are used
    // Value 0x61417272
    uint32 Free_Count; // the last known free cluster count on the volume.
    // If the value is 0xFFFFFFFF, then the free count is unknown and must be computed.
    uint32 Nxt_Free;
    // the cluster number at which the driver should start looking for free clusters
    uchar Reserved2[12];
    uchar TrailSig[4]; // validate that this is in fact an FSInfo sector
    // Value 0xAA550000
} __attribute__((packed)) fsinfo_t;
```

## mount的解释：
当你挂载一个文件系统镜像到 /mnt 目录时，操作系统会将该目录作为挂载点，用于访问文件系统镜像中的内容。在这个过程中，挂载点目录（在这个例子中是 /mnt）的原有内容会被隐藏，操作系统会将挂载的文件系统镜像中的内容呈现在挂载点上。

如果在挂载状态下，你向 /mnt 目录添加了文件，这些文件实际上被添加到了文件系统镜像中，而不是物理的 /mnt 目录。这是因为挂载操作使得文件系统镜像的内容在挂载点上可见，任何写入挂载点的操作都相当于直接写入文件系统镜像。

当你执行 umount 命令卸载文件系统镜像后，挂载点 /mnt 会恢复到原来的状态，显示它在挂载文件系统镜像之前的内容。由于你添加的文件实际上是写入到了文件系统镜像中，所以在卸载镜像后，这些文件会保留在镜像文件里，而不是在 /mnt 目录下。

如果你想查看或访问这些文件，你需要重新挂载该文件系统镜像到 /mnt 或任何其他目录，然后就可以访问到之前添加的文件了。

总结来说，挂载文件系统镜像时添加的文件会保存在镜像文件中，而不是挂载点的物理目录中。卸载镜像后，这些文件不会在挂载点目录出现，但可以通过重新挂载镜像来访问它们