# 初赛文档

## 在线测试

2024操作系统赛-内核实现全国初赛-VisionFive 2 赛道

初赛功能测试满分：

![rank](../img/rank.png)

## 环境与配置

- 交叉编译器 riscv64-unknown-elf-gcc
- QEMU模拟器 qemu-riscv64
- RISC-V GCC编译链

### 快速开始

首先克隆 RISC-V GNU Compiler Toolchain的存储库

```bash
git clone --recursive https://github.com/riscv/riscv-gnu-toolchain
```

安装实验编译工具链所需要的包

```bash
sudo apt-get install autoconf automake autotools-dev curl libmpc-dev libmpfr-dev libgmp-dev gawk build-essential bison flex texinfo gperf libtool patchutils bc zlib1g-dev libexpat-dev
```

进入toolchain目录并配置

```bash
cd riscv-gnu-toolchain
./configure --prefix=/usr/local
sudo make
cd ..
```

安装QEMU

```bash
wget https://download.qemu.org/qemu-5.1.0.tar.xz
tar xf qemu-5.1.0.tar.xz
cd qemu-5.1.0
./configure --disable-kvm --disable-werror --prefix=/usr/local --target-list="riscv64-softmmu"
make
sudo make install
cd..
```

下载项目源码

```bash
git clone https://gitlab.eduxiji.net/T202410183992516/oskernel2024-10183boot
```

在QEMU上运行，生成FAT32镜像文件

```bash
make fs
```

运行

```bash
make run
```

## 文件结构

.

├── docs（比赛说明文档）`<br>`
├── kernel（内核源码）`<br>`
│   └── include `<br>`
├── linkscript `<br>`
├── mkfs `<br>`
└── user `<br>`

## 系统调用和测试

[syscalls说明](https://github.com/oscomp/testsuits-for-oskernel/blob/pre-2024/oscomp_syscalls.md)

系统调用方式遵循RISC-V ABI,即调用号存放在a7寄存器中,6个参数分别储存在a0-a5寄存器 中,返回值保存在a0中。

主要参考[Linux 5.10 syscalls](https://man7.org/linux/man-pages/man2/syscalls.2.html)

### 测试配置、编译、运行

[riscv-syscalls-testing](https://github.com/oscomp/testsuits-for-oskernel/tree/pre-2024/riscv-syscalls-testing)
