#ifndef _FILE_SYSTEM_H_
#define _FILE_SYSTEM_H_

#include "include/types.h"
#include "include/block/buf.h"
#include "include/fs/fat32/fat32.h"
#include "include/fs/vfs/fs.h"
#define MAX_NAME_LENGTH 64

struct buf;
typedef struct FileSystem {
    u8 valid;
    char name[MAX_NAME_LENGTH];
    struct superblock superBlock;
    struct dirent root;
    struct file *image;
    FileSystem *next;
    int deviceNumber;
    struct buf* (*read)(struct FileSystem *fs, u64 blockNum);
} FileSystem;

typedef struct DirentCache {
    struct spinlock lock;
    struct dirent entries[ENTRY_CACHE_NUM];
} DirentCache;

int fsAlloc(FileSystem **fs);
int fatInit(FileSystem *fs);
void initDirentCache();
int fatInit(FileSystem *fs);

#endif