#ifndef _FCNTL_H
#define _FCNTL_H

#define F_RDONLY  0x000
#define F_WRONLY  0x001
#define F_RDWR    0x002
#define F_APPEND  0x004
#define F_CREATE  0x040
#define F_TRUNC   0x400
#define F_DIRECTORY 0x0200000
#define F_CLOEXEC 02000000

// #define O_CLOEXEC 01

#define DIR 0x040000
#define FILE 0x100000

#define AT_FDCWD -100
#define AT_REMOVEDIR 0x200

#define PROT_NONE       0x0
#define PROT_READ       0x1
#define PROT_WRITE      0x2
#define PROT_EXEC       0x4

#define MAP_SHARED      0x01
#define MAP_PRIVATE     0x02


// faccess
#define F_OK 0           /* test existance */
#define R_OK 4           /* test readable */
#define W_OK 2           /* test writable */
#define X_OK 1           /* test executable */
#define AT_EACCESS 0x100 /* 使用进程的有效用户ID 和 组ID */

// fcntl
#define F_DUPFD 0    /* dup */
#define F_GETFD 1    /* get close_on_exec */
#define F_SETFD 2    /* set/clear close_on_exec */
#define F_GETFL 3    /* get file->f_flags */
#define F_SETFL 4    /* set file->f_flags */
#define FD_CLOEXEC 1 /* actually anything with low bit set goes */
#define F_DUPFD_CLOEXEC 1030

// lseek
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2

#endif