#ifndef _STAT_H
#define _STAT_H
#define T_DIR     1   // Directory
#define T_FILE    2   // File
#define T_DEVICE  3   // Device
#define T_LINK 4

// struct stat {
//   int dev;     // File system's disk device
//   uint ino;    // Inode number
//   short type;  // Type of file
//   short nlink; // Number of links to file
//   uint64 size; // Size of file in bytes
// };
struct stat {
  uint64 st_dev;
  uint64 st_ino;
  uint32 st_mode;
  uint32 st_nlink;
  uint32 st_uid;
  uint32 st_gid;
  uint64 st_rdev;
  uint16 __pad2;
  uint64 st_size;
  uint32 st_blksize;
  uint64 st_blocks;
  uint64 st_atime;
  uint64 st_atimensec;
  uint64 st_mtime;
  uint64 st_mtimensec;
  uint64 st_ctime;
  uint64 st_ctimensec;
  uint64 _unused[2];
    // char name[STAT_MAX_NAME + 1]; //[ADD] file name
    // short type;   // Type of file
};

struct statfs {
    uint64 f_type;    /* Type of filesystem (see below) */
    uint64 f_bsize;   /* Optimal transfer block size */
    uint64 f_blocks;  /* Total data blocks in filesystem */
    uint64 f_bfree;   /* Free blocks in filesystem */
    uint64 f_bavail;  /* Free blocks available to
                            unprivileged user */
    uint64 f_files;   /* Total inodes in filesystem */
    uint64 f_ffree;   /* Free inodes in filesystem */
    struct {
        int val[2];
    } f_fsid;         /* Filesystem ID */
    uint64 f_namelen; /* Maximum length of filenames */
    uint64 f_frsize;  /* Fragment size (since Linux 2.6) */
    uint64 f_flags;   /* Mount flags of filesystem
                            (since Linux 2.6.36) */
    uint64 f_spare[4];
                    /* Padding bytes reserved for future use */
};

#endif