#ifndef _PARAM_H
#define _PARAM_H

#define NPROC        64  // maximum number of processes
#define NCPU          8  // maximum number of CPUs
#define NOFILE      128  // open files per process
#define NFILE       100  // open files per system
#define NINODE       50  // maximum number of active i-nodes
// #define NDEV         10  // maximum major device number
#define ROOTDEV       1  // device number of file system root disk
#define MAXARG       32  // max exec arguments
#define MAXOPBLOCKS  10  // max # of blocks any FS op writes
#define LOGSIZE      (MAXOPBLOCKS*3)  // max data blocks in on-disk log
#define NBUF         (MAXOPBLOCKS*3)  // size of disk block cache
#define FSSIZE       2000  // size of file system in blocks
#define MAXPATH      128   // maximum file path name
#define AT_FDCWD     -100
#define EXT4_MAX_PATH 255

#define CLK_FREQ     10000000
#define ticks_per_second 10
#define INTERVAL     CLK_FREQ / ticks_per_second // timer interrupt interval

#define USTACKSIZE   8 //用户栈默认8*4k
#endif