#ifndef __TIMER_H
#define __TIMER_H

#include "include/types.h"
#include "include/kernel/atomic/spinlock.h"
#include "include/kernel/param.h"

#define ITIMER_REAL 0
#define ITIMER_VIRTUAL 1
#define ITIMER_PROF 2

#define NTIMERS 10

extern struct spinlock tickslock;
extern uint ticks;


struct tms              
{                     
	long tms_utime;  
	long tms_stime;  
	long tms_cutime; 
	long tms_cstime; 
};

struct timespec {
	long tv_sec;	// seconds
	long tv_nsec;	// nanoseconds
};

struct timeval {
    time_t      tv_sec;         // 秒数
    suseconds_t tv_usec;        // 微秒数
};

#endif
