OUTPUT_ARCH( "riscv" )
ENTRY( _entry )

SECTIONS
{
  /*
   * ensure that entry.S / _entry is at 0x80000000,
   * where qemu's -kernel jumps.
   */
  . = 0x80200000;

  .text : {
    *(.text .text.*)
    . = ALIGN(0x1000);
    _trampoline = .;
    *(trampsec)
    . = ALIGN(0x1000);
    ASSERT(. - _trampoline == 0x1000, "error: trampoline larger than one page");
    PROVIDE(etext = .);
  }

  .rodata : {
    . = ALIGN(16);
    *(.srodata .srodata.*) /* do not need to distinguish this from .rodata */
    . = ALIGN(16);
    *(.rodata .rodata.*)
  }

  .data : {
    . = ALIGN(16);
    *(.sdata .sdata.*) /* do not need to distinguish this from .data */
    . = ALIGN(16);
    *(.data .data.*)
  }

.bss : {
    . = ALIGN(16);
    __bss_start = .; /* 定义 .bss 段的开始 */
    *(.sbss .sbss.*)
    . = ALIGN(16);
    *(.bss .bss.*)
    __bss_end = .; /* 定义 .bss 段的结束 */
    . = ALIGN(16);
}
.sddata : {
        . = ALIGN(8); /* 确保对齐 */
        __sddata_start = .;
        *(.sddata)
        __sddata_end = .;
        . = ALIGN(8);
    }

  PROVIDE(end = .);
}
