
#include "include/mm/memlayout.h"
#include "include/types.h"
#include "include/riscv.h"
#include "include/kernel/param.h"
#include "include/defs.h"
#include "include/kernel/proc.h"
#include "include/kernel/atomic/spinlock.h"
#include "include/mm/kmm.h"

void *kmalloc(uint size)
{   
    void* tmp = kalloc();
    memset(tmp, 0, PGSIZE);
    return tmp;
}

void *kcalloc(int n, uint size)
{
    if (n == 1) {
        return kmalloc(size);
    } else {
        panic("[kcalloc] not implemented times above 1!");
    }  
}

void kmfree(void *addr)
{
    kfree(addr);
}