#!/bin/bash

# 指定 syscall.h 文件的路径
header_file="../include/kernel/syscall.h"

# 指定输出的 C 文件路径
output_file="../kernel/syscall/syscall.c"
temp_dec="temp_dec.c"
temp_vec="temp_vec.c"

#清除原有的syscall数组和声明
sed -i '/extern/d' $output_file
#sed -i '/static/d' $output_file
sed -i '/\[SYS_/d' $output_file

# 开始构建 syscalls 数组
grep "^#define SYS_" $header_file | awk '{print "    [" $2 "]    " tolower($2) ","}' >> $temp_vec

grep "^#define SYS_" $header_file |  awk '{print "extern uint64 " tolower($2) "(void);"}' >> $temp_dec

sed -i "/SYSCALL_DEC/r $temp_dec" $output_file

sed -i "/static uint64 (\*syscalls\[])(void) = /r $temp_vec" $output_file

rm $temp_vec $temp_dec
