#include "include/types.h"
#include "include/fs/vfs/stat.h"
#include "include/user.h"
// simple fork and pipe read/write
#define bufsz 1050
char buf[bufsz];
// #define DEBUG_PIPE
void
pipe1(char *s)
{
  int fds[2], pid, xstatus;
  int seq, i, n, cc, total;
  enum { N=5, SZ=1033 };
  
  if(pipe2(fds) != 0){
    printf("%s: pipe() failed\n", s);
    exit(1);
  }
  pid = fork();
  seq = 0;
  if(pid == 0){
    //父进程写，关闭读端
    close(fds[0]);
    for(n = 0; n < N; n++){
      for(i = 0; i < SZ; i++)
        buf[i] = seq++;
      if(write(fds[1], buf, SZ) != SZ){
        printf("%s: pipe1 oops 1\n", s);
        exit(1);
      }
      #ifdef DEBUG_PIPE
        printf("parent wirte %d times\n",n);
      #endif
    }
    exit(0);
  } else if(pid > 0){
    //子进程读，关闭写端
    close(fds[1]);
    total = 0;
    cc = 1;
    while((n = read(fds[0], buf, cc)) > 0){
      for(i = 0; i < n; i++){
        if((buf[i] & 0xff) != (seq++ & 0xff)){
          printf("%s: pipe1 oops 2\n", s);
          return;
        }
        #ifdef DEBUG_PIPE
            printf("child receive %d times\n",i);
        #endif
      }
      total += n;
      cc = cc * 2;
      if(cc > sizeof(buf))
        cc = sizeof(buf);
    }
    if(total != N * SZ){
      printf("%s: pipe1 oops 3 total %d\n", total);
      exit(1);
    }
    close(fds[0]);
    printf("end test pipe\n");
    wait(&xstatus);
    exit(xstatus);
  } else {
    printf("%s: fork() failed\n", s);
    exit(1);
  }
}

int main(void){
    pipe1("test");
    exit(0);
}