#include "include/defs.h"
#include "include/string.h"
#include "include/fs/vfs/stat.h"
#include "include/fs/vfs/file.h"
#include "include/kernel/param.h"
// #include "include/sysfile.h"
// #include "include/debug.h"

char test_content_to_write[10] = "abcdefghi";
char test_content_to_read[10] = {0};

void testfat() {
    printf("[testfat] testing fat.......\n");
    struct dirent* testfile = create(AT_FDCWD, "/testfile", T_FILE, O_CREATE | O_RDWR);
    if (testfile == NULL) {
        panic("[testfat] create file error\n");
    }
    // MSG_PRINT("create file finish");
    for(int i=0;i<4096;++i){
    int ret = ewrite(testfile, 0, (u64)test_content_to_write, i*9, 9);
    if (ret != 9) {
        panic("[testfat] write file error\n");
    }
    }

    // MSG_PRINT("write file finish");
    eunlock(testfile);
    eput(testfile);
    // MSG_PRINT("eput file finish");
    testfile = ename(AT_FDCWD, "/testfile");
    if (testfile == NULL) {
        printf("[testfat] open file error\n");
    }
    // DEC_PRINT(testfile->ref);
    int fail = -1;
    for(int i=0;i<4096;++i){
    eread(testfile, 0, (u64)test_content_to_read, i*9, 9);
    if (strncmp(test_content_to_write, test_content_to_read, 9)==0) {
        // printf("[testfat]  testfat passed\n");
    } else {
        fail = i;
        break;
    }
    }
    if(fail == -1)
        printf("[testfat]  testfat success\n");
    else
        printf("[testfat]  testfat failed on i = %d\n", fail);
}