#include "include/init/sbi.h"
#include "include/defs.h"
#include "include/user.h"

extern uint64 sys_dup(void);

char *syscallList[] = {
    "brk",
    "chdir",
    "clone",
    "close",
    "dup",
    "dup2",
    "execve",
    "exit",
    "fork",
    "fstat",
    "getcwd",
    "getdents",
    "getpid",
    "getppid",
    "gettimeofday",
    "mkdir_",
    "mmap",
    "mount",
    "munmap",
    "open",
    "openat",
    "pipe",
    "read",
    "sleep",
    "test_echo",
    "times",
    "umount",
    "uname",
    "unlink",
    "wait",
    "waitpid",
    "write",
    "yield",
    // "sh",
};

char *argv[] = {NULL};
// char *argv[]={"ls", "arg1", "arg2", 0};

void testSyscall()
{
    if(open("console", O_RDWR) < 0){
        mknod("console", CONSOLE, 0);
        open("console", O_RDWR);
    }
    dup(0);  // stdout
    dup(0);  // stderr


    for (int i = 0; i < sizeof(syscallList) / sizeof(char *); i++)
    {
        int pid = fork();
        if (pid == 0)
        {   
            char*path = "../testcases/"; //TODO 路径改一下
            exec(syscallList[i], argv);
        }
        else
        {
            wait(0);
        }
    }
    sbi_shutdown(0);
}
